/* High level client IPC API for sockets and QNX message passing.
   Rick Smereka, Copyright (C) 1998-2002.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, get a copy via the Internet at
   http://gnu.org/copyleft/gpl.html or write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307 USA

   You can contact the author via email at rsmereka@future-lab.com

   Original 32bit Windows version Dec/98, Rick Smereka

   Ported to HP-UX under GNU C 2.8.1.
   Jan/99, Rick Smereka

   Ported to Red Hat Linux 5.2, Jul/99, Rick Smereka

   Added 'extern "C"' sections in the case of a C++ compiler
   Apr/2000, Rick Smereka
   
   Removed 'ipc_init', 'ipc_recv_data' and 'ipc_send_data'.
   Added prototypes 'ipc_set_active', 'ipc_get_active' and
   'ipc_send_receive'. May/2000, Rick Smereka

   Modified for use with sockets and QNX message passing.
   Sep/2001, Rick Smereka

   Ported to Debian Linux. Nov/2002, Rick Smereka */

#ifdef __cplusplus
extern "C"
{
#endif

#ifdef IPC_TCP
int ipc_set_active(char *, int);
int ipc_get_active(char *, int *);
int ipc_send_receive(char *, char *);
int ipc_close(void);
#else
int ipc_set_active(char *);
int ipc_get_active(char *);
int ipc_send_receive(char *, char *, int);
#endif

#ifdef __cplusplus
}
#endif
